var gDialog = {};

var MathMLHelper = {

  kMATHML_NAMESPACE: "http://www.w3.org/1998/Math/MathML",
  mCurrentElement: null,
  mCurrentEditor: null,

  startup: function()
  {
    var elts = document.getElementsByAttribute("id", "*");
    for (var i = 0; i < elts.length; i++)
    {
      var elt = elts.item(i);
      gDialog[ elt.getAttribute("id") ] = elt;
    }

    this.mCurrentEditor  = window.arguments[0];
    this.mCurrentElement = window.arguments[1];

    this.selectionChanged();
  },

  shutdown: function()
  {
  },

  loadExternalURL: function( url )
  {
    if (url)
    { 
      var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                                .getService(Components.interfaces.nsIIOService);
      var uri = ioService.newURI(url, null, null);
      var extProtocolSvc = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
                                     .getService(Components.interfaces.nsIExternalProtocolService);
  
      extProtocolSvc.loadURI(uri);
    }
  },

  selectionChanged: function()
  {
    var elt = MathMLHelper.mCurrentElement
    while (elt && (elt.namespaceURI != MathMLHelper.kMATHML_NAMESPACE ||
                    elt.nodeName.toLowerCase() != "math"))
      elt = elt.parentNode;
    MathMLHelper.mCurrentElement = elt;

    var w = gDialog.mathmlIframe.contentWindow.wrappedJSObject; 

    if (!elt || elt.namespaceURI != MathMLHelper.kMATHML_NAMESPACE) {
      gDialog.mathmlIframe.contentDocument.getElementById("inputText").value = "";
      gDialog.mathmlInsertButton.hidden = false;
      gDialog.mathmlUpdateButton.hidden = true;
      w.display();
      return;
    }

    // find the ASCIIMathML tex
    var prose = "";
    var asciiComment = elt.firstChild;
    if (asciiComment &&
        asciiComment.nodeType == Node.COMMENT_NODE) {
      prose = asciiComment.data;
    }
    else if (elt.hasAttribute("title")) {
      prose = elt.getAttribute("title");
    }
    if (prose) {
      gDialog.mathmlIframe.contentDocument.getElementById("inputText").value = prose;
      gDialog.mathmlInsertButton.hidden = true;
      gDialog.mathmlUpdateButton.hidden = false;
      w.display();
    }
    else {
      // not created by us...
      gDialog.mathmlIframe.contentDocument.getElementById("inputText").value = "";
      gDialog.mathmlInsertButton.hidden = true;
      gDialog.mathmlUpdateButton.hidden = true;
      w.display();
    }
  },

  insertMathML: function()
  {
    var outputNode = gDialog.mathmlIframe.contentDocument.getElementById("outputNode");
    var child = outputNode.firstChild;
    var prose = gDialog.mathmlIframe.contentDocument.getElementById("inputText").value;
    while (child) {
      if (child.nodeType != Node.TEXT_NODE) {
        var clone = this.mCurrentEditor.document.importNode(child, true);
        if (child.nodeName == "math" && child.namespaceURI == MathMLHelper.kMATHML_NAMESPACE) {
          var comment = clone.ownerDocument.createComment(child.getAttribute("title"));
          clone.removeAttribute("title");
          clone.insertBefore(comment, clone.firstChild);
          this.mCurrentEditor.insertElementAtSelection(clone, true);
        }
      }
      else if (child.data && child.data.match( /[^\s]/ ))
        this.mCurrentEditor.insertHTML(child.data);

      child = child.nextSibling;
    }

    window.close();
  },

  updateMathML: function()
  {
    this.mCurrentEditor.selectElement(MathMLHelper.mCurrentElement);
    MathMLHelper.insertMathML();
  }
};
